GenAuth DocsDocuments
Concepts
User Guide
Development Integration
AgentAuth
Metadata
Development Integration
Multi-tenant (beta)
Console Documentation
Multi-tenant Console
Tenant Console
Saas Application Demo
Concepts
User Guide
Development Integration
AgentAuth
Metadata
Development Integration
Multi-tenant (beta)
Console Documentation
Multi-tenant Console
Tenant Console
Saas Application Demo
Old version
Development Integration
  • API

  • SDK

    • Java

      • Installation and use
      • User authentication module

      • Management module

        • Manage users

        • Management Roles

        • Manage user groups

        • Manage custom fields

        • Manage Resources and Permissions

        • Manage data resources and permissions

          • Create permission space
          • Batch create permission spaces
          • Get permission space details
          • Batch get permission space details list
          • Paged get permission space list
          • Modify Permission Space
          • Delete Permission Space
          • Batch Delete Permission Space
          • Check whether the permission space Code or name is available
          • Paginated query of all roles in the permission space
          • Create data resources
          • Create string data resources
          • Create array data resources
          • Create tree data resources
          • Get data resource list
          • Get data resource information
          • Modify data resources
          • Delete data resources
          • Check data resource name or Code Is it available
          • Create data resource extension fields
          • Batch create data resource extension fields
          • Delete data resource extension fields
          • Modify data resource extension fields
          • Get data resource extension field list
          • Create data policy
          • Get data policy list
          • Get a list of simple data policy information
          • Get data policy information
          • Modify data policy
          • Delete data policy
          • Check whether the data policy name exists
          • Get all the information of the authorized subjects under the data policy
          • Authorize Data Policy
          • Revoke Data Policy
          • Get User Permission List
          • Judge user permissions
          • Judge external user permissions
          • Get user-specified resource permission list
          • Get a list of users authorized to use resources
          • Get a list of user-authorized resources
          • Get the structure list of external user authorization resources
          • Judge the user's permissions under the same level resources of the tree resource
        • Manage Applications

        • Manage Identity Sources

        • Manage security configuration

        • Manage message service

        • Manage Pipeline

        • Manage Webhook

        • Get audit log

        • Manage metering and billing

        • Events
    • Node.js

    • Python

  • Error Codes
  1. Development Integration
  2. /
  3. SDK
  4. /
  5. Java
  6. /
  7. Management module

  8. /
  9. Manage data resources and permissions

  10. /
  11. Create tree data resources

¶ Create a tree data resource

Update time: 2025-07-23 07:34:21
Edit

This document is automatically generated based on https://github.com/authing/authing-docs-factory based on https://api-explorer.genauth.ai V3 API, and is consistent with API parameters and return results. If this document description is incorrect, please refer to V3 API.

When you only need to create a tree type data resource, you can use this API. We have fixed the data resource type, and you do not need to pass in the type character field. Note: struct should be passed in according to the tree type data resource structure, please refer to the example.

¶ Method Name

ManagementClient.createDataResourceByTree

¶ Request Parameters

NameType
Is it required
Default Value
Description
Example Value
actionsstring[]Yes-Data resource permission operation list Array length limit: 50.["read","get"]
structDataResourceTreeStructs[]Yes-Tree data resource node Array length limit: 50.
resourceCodestringyes-Data resource Code, unique in the permission spacedataResourceTestCode
resourceNamestringyes-Data resource Name, unique in the permission spaceSample data resource Name
namespaceCodestringyes-Permission space where the data policy is locatedcode1
descriptionstringno-Data resource descriptionSample Data Resource Description
extendFieldListDnef[]no-Data resource extension field

¶ Sample Code

package test.management.dataPermission.resource;

import cn.authing.sdk.java.client.ManagementClient;
import cn.authing.sdk.java.dto.CreateTreeDataResourceDto;
import cn.authing.sdk.java.dto.CreateTreeDataResourceResponseDto;
import cn.authing.sdk.java.dto.DataResourceTreeStructs;
import cn.authing.sdk.java.dto.Dnef;
import cn.authing.sdk.java.dto.DnefConfig;
import cn.authing.sdk.java.model.ManagementClientOptions;
import cn.authing.sdk.java.util.JsonUtils;
import cn.hutool.core.collection.ListUtil;
import cn.hutool.core.map.MapUtil;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public class CreateDataResourceByTreeTest {
    // Need to be replaced with your GenAuth Access Key ID
    private static final String ACCESS_KEY_ID = "AUTHING_ACCESS_KEY_ID";
    // Need to be replaced with your GenAuth Access Key Secret
    private static final String ACCESS_KEY_SECRET = "AUTHING_ACCESS_KEY_SECRET";

    public static void main(String[] args) throws Throwable {
        ManagementClientOptions clientOptions = new ManagementClientOptions();
        clientOptions.setAccessKeyId(ACCESS_KEY_ID);
        clientOptions.setAccessKeySecret(ACCESS_KEY_SECRET);
        // If you are a private deployment customer, you need to set the GenAuth service domain name
        // clientOptions.setHost("https://api.your-authing-service.com");
        ManagementClient client = new ManagementClient(clientOptions);

        CreateTreeDataResourceDto reqDto = new CreateTreeDataResourceDto();
        reqDto.setActions(Collections.singletonList("read"));
        reqDto.setResourceCode("treeResourceCode");
        reqDto.setResourceName("Example Tree Data Resource");
        reqDto.setNamespaceCode("examplePermissionNamespace");
        List<DataResourceTreeStructs> treeList = new ArrayList<>();
        DataResourceTreeStructs struct = new DataResourceTreeStructs();
        struct.setCode("tree1");
        struct.setName("tree node 1");
        struct.setExtendFieldValue(MapUtil.of("str", "str_value"));
        struct.setValue("tree node 1 description");
        List<Object> children = new ArrayList<>();
        DataResourceTreeStructs child = new DataResourceTreeStructs();
        child.setName("tree node 11");
        child.setCode("tree11");
        child.setValue("tree node 11 description");
        children.add(child);
        struct.setChildren(children);
        treeList.add(struct);
        reqDto.setStruct(treeList);
        reqDto.setDescription("Example Tree Data Resource description");
        // Set extended fields (optional)
        // Set extension fields (optional)
        reqDto.setExtendFieldList(buildDnef());
        CreateTreeDataResourceResponseDto response = client.createDataResourceByTree(reqDto);
        System.out.println(JsonUtils.serialize(response));
    }

    /**
     * Building extension fields
     */
    private static List<Dnef> buildDnef() {
        List<Dnef> dnefs = new ArrayList<>();
        Dnef str = new Dnef();
        str.setKey("str");
        str.setLabel("str_label");
        str.setValueType(Dnef.ValueType.STRING);
        str.setDescription("string");
        dnefs.add(str);

        Dnef select = new Dnef();
        select.setKey("select");
        select.setLabel("select_label");
        select.setValueType(Dnef.ValueType.SELECT);
        select.setDescription("select");
        List<DnefConfig.Option> options = ListUtil.of(
          new DnefConfig.Option("option1"),
          new DnefConfig.Option("option2"),
          new DnefConfig.Option("option3")
        );
        DnefConfig config = new DnefConfig(options);
        select.setConfig(config);
        dnefs.add(select);

        return dnefs;
    }
}

¶ Request Response

Type: CreateTreeDataResourceResponseDto

NameTypeDescription
statusCodenumberBusiness status code. You can use this status code to determine whether the operation is successful. 200 means success.
messagestringDescription
apiCodenumberSegment error code, through which the specific error type can be obtained (not returned for successful requests). For a detailed list of error codes, see:API Code List (opens new window)
requestIdstringRequest ID. Returned when the request fails.
dataCreateTreeDataResourceRespDtoResponse data

Example Results:

{
  "statusCode": 200,
  "message": "Operation successful",
  "requestId": "934108e5-9fbf-4d24-8da1-c330328abd6c",
  "data": {
    "resourceName": "Sample data resource Name",
    "resourceCode": "dataResourceTestCode",
    "type": "TREE",
    "description": "Sample Data Resource Description",
    "struct": {
      "code": "123",
      "name": "Data resource",
      "value": "Sample data resource node",
      "children": [
        {
          "code": "code1",
          "name": "Child node 1",
          "value": "Child node value",
          "children": [
            {
              "code": "code2",
              "name": "Child node 2",
              "value": "Child node 2 value"
            }
          ]
        }
      ]
    },
    "actions": ["read", "get"]
  }
}

¶ Data Structure

¶ DataResourceTreeStructs

NameType
Is it required
Description
Example Value
codestringyesData resource node Code, unique in the same level123
namestringyesData resource node Name, unique in the same levelData resource
valuestringnoData resource node ValueSample data resource node
childrenarraynoChild nodes of data resource node, child node level supports up to five levels[{"code":"code1","name":"child node 1","value":"child node value","children":[{"code":"code2","name":"child node 2","value":"child node 2 value"}]}]
extendFieldValuemapnoExtend field value{"str":"str_value"}

¶ CreateTreeDataResourceRespDto

NameType
Is it required
Description
Example Value
resourceNamestringyesData resource Name, unique in the permission spaceSample data resource Name
resourceCodestringyesData resource Code, unique in the permission spacedataResourceTestCode
typestringyesData resource type, currently supports tree structure (TREE), string (STRING), array (ARRAY)TREE
descriptionstringnoData resource descriptionSample Data Resource Description
structarrayyesTree data resource node nested Type: DataResourceTreeStructs. Array length limit: 50.
actionsarrayYesData resource permission operation list Array length limit: 50.["read","get"]
extendFieldListDnef[]NoData resource extension field

¶ DataResourceTreeStructs

NameType
Is it required
Description
Example Value
codestringYesData resource node Code, unique at the same level123
namestringYesData resource node Name, unique at the same levelData Resource
valuestringNoData resource node ValueSample data resource node
childrenarrayNoChild nodes of the data resource node, the child node level supports up to five levels[{"code":"code1","name":"child node 1","value":"child node value","children":[{"code":"code2","name":"child node 2","value":"child node 2 value"}]}]

¶ Dnef

NameType
Is it required
Description
Example Value
keystringYesExtended field Keystr
valueTypeValueTypeYesExtended field value typeSTRING (text), SELECT (single choice)
labelstringYesExtended field display Namestr_label
configDnefConfigNoField configuration, single choice type field must be passed

¶ DnefConfig

NameType
Is it required
Description
Example Value
optionsOption[]YesSingle-select type field option list

¶ Option

NameType
Is it required
Description
Example Value
valuestringYesOption valueoption1
Previous article: Create array data resources Next article: Get data resource list
  • Method Name
  • Request Parameters
  • Sample Code
  • Request Response
  • Data Structure

User identity management

Integrated third-party login
Customized authentication process

Enterprise internal management

Single sign-on
Multi-factor authentication
Permission management

Developer

Development Documentation
GitHub (opens new window)

Company

official@genauth.ai
16th Floor, Building B, Beichen Century Center, Chaoyang District, Beijing (Total)
Room 406, 4th Floor, Block B, No. 200, Tianfu Fifth Street, High-tech Zone, Chengdu (Branch)

© Beijing Steamory Technology Co., Ltd.